# transforms a Pajek's temporal network in temporal matrix
#   with open("violence.p","rb") as p: V = pickle.load(p)
# Vladimir Batagelj, 22. Jan 2015

import os, re, pickle, datetime
from TQ import *
os.chdir('E:/data/airports/')
print('start:',datetime.datetime.now().ctime())
net = open('flights.net','r')
n = 2776
ten = open('flights.ten', "w")

ten.write("*nodes "+str(n)+"\n")
while True:
   line = net.readline()
   if line[0]=='*': break
k = 0; names = ['']*n; C = [[(1,296,1)]]*n
while True:
   line = net.readline()
   if (line[0]=='*') or (k>=n): break
   L = re.split('\s+',line.strip())
   j = eval(L[0])-1; names[j] = L[1][1:-1]
   ten.write(L[0]+' '+L[1]+' [(1,296,1)]\n')
   k = k+1
while True:
   line = net.readline()
   if line[0]!='*': break

print('nodes done:',datetime.datetime.now().ctime())
W = [[ [] for u in range(n)] for v in range(n)]
ten.write("*arcs\n")
while line:
   L = re.split('\s+',line.strip())
   u = eval(L[1])-1; v = eval(L[2])-1
#   if v<u: (u,v) = (v,u)
   w = eval(L[3]); t = eval(L[4][1:-1])
   W[u][v] = TQ.sum(W[u][v],[(t,t+1,w)])
   line = net.readline()

for u in range(n):
   for v in range(n):
      if W[u][v]!=[]:
         ten.write(str(u+1)+' '+str(v+1)+' '+str(W[u][v])+'\n')
         
net.close()
ten.close()
print('arcs done:',datetime.datetime.now().ctime())

Months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec' ]
time = [ v+str(u)[2:] for u in range(1990,2015) for v in Months ][:294]
flights = {}

flights['tit'] = 'Flights'
flights['num'] = n
flights['nam'] = names
flights['act'] = C
flights['tim'] = time
flights['mat'] = W
with open("flights.p","wb") as p: pickle.dump(flights,p)
print('saved:',datetime.datetime.now().ctime())

