# constructs airports' attributes
# vladimir Batagelj, January 24, 2015
import os, re, csv, datetime
global air, cnt

def indAirport(name):
  global air
  if not(name in air.keys()): air[name] = len(air)+1
  return air[name]

def indCountry(name):
  global cnt
  if not(name in cnt.keys()): cnt[name] = len(cnt)+1
  return cnt[name]

os.chdir('E:/data/airports')

print('start Construct:',datetime.datetime.now().ctime())
print('Countries')

cnt  = {}; air = {}
countries = open('countries.dat', 'r')
row = countries.readlines()
countries.close()
for r in row: ind = indCountry(r[:-1])


line = 0
with open('airportsHead.csv', newline='', encoding='utf-8') as dat:
  airReader = csv.reader(dat, delimiter=',', quotechar='"')
  try:
    head = next(airReader)
    print('|'.join(head))
    for row in airReader:
      nam = row[1]; cny = row[3]
      iata = row[4]; icao = row[5]; tiz = row[9]
      lat = row[6]; lon = row[7]; alt = row[8]
      icny = indCountry(cny)
      if len(iata)>2:
        air[iata] = ( nam, iata, icao, icny, cny, lat, lon, alt)
      elif len(icao)==3:
        air[icao] = ( nam, iata, icao, icny, cny, lat, lon, alt)  
      else: print('missing data', line, nam)
      line = line+1
  except csv.Error as e:
    sys.exit('file {}, line {}: {}'.format(podatki, airReader.line_num, e))
print("lines = ",line,"\nairports = ",len(air))

attrs = open('airports.atr', 'w')
attrs.write('*vertices \n')
airports = open('airports.tmp', 'r')
rows = airports.readlines()[1:]
airports.close()
for r in rows:
  s = r.split(' ')
  ap = s[1][1:-2]; an = int(s[0])
  if ap in air.keys():
    ( nam, iata, icao, icny, cny, lat, lon, alt) = air[ap]
    attrs.write(s[0]+';"'+nam+'";"'+iata+'";"'+icao+'";'+str(icny)+';"'+ \
      cny+'";'+str(lat)+';'+str(lon)+';'+str(alt)+'\n')          
  else:
    print("not found", an, ap)
    attrs.write(s[0]+';"?";"'+ap+'";"'+ap+'";0;"?";0;0;0\n')               
attrs.close()

print('finished:',datetime.datetime.now().ctime())


