import os, re, datetime
from TQ import *
from operator import itemgetter

os.chdir('E:/data/airports')

print('start Extract:',datetime.datetime.now().ctime())
print('Network Flights')
AIR = TQ.Ianus2Mat("./Flights.ten")
print('input done:',datetime.datetime.now().ctime())
mat = AIR['mat']
print('sum =',TQ.MatSummary(mat))
print(AIR.keys())
print('dim =',AIR['dim'])
print('met =',AIR['met'])
print('nam =',AIR['nam'][0:10])
print('tit =',AIR['tit'])
print('typ =',AIR['typ'])
print('tin =',AIR['tin'][0:10])
print('til =',AIR['til'][0:10])
(nr,nc,tmin,tmax) = AIR['dim']
n = len(mat); All = range(n)
names = AIR['nam']
# times = AIR['til']
# act   = AIR['act']

A = [[]]*n; S = [0]*n
for u in range(n):
   a = []
   for v in range(n): 
      a = TQ.sum(a,mat[v][u]) 
   A[u] = a; S[u] = TQ.total(a)
   
P = sorted(enumerate(S),key=itemgetter(1),reverse=True)
for i in range(100):
   print(i+1,names[P[i][0]],P[i][1])

B = [[ [] for u in range(100)] for v in range(100)]
L = []; nam = []
for (i,v) in P[0:100]:
   L.append(i); nam.append(names[i])
for (i,u) in enumerate(L):
   for (j,v) in enumerate(L):
      B[i][j] = mat[u][v]

best = {}
best['mat'] = B
best['dim'] = (100,100,1,295)
best['met'] = AIR['met']            
best['nam'] = nam
best['tit'] = "100 largest airports"
best['typ'] = AIR['typ']
best['til'] = AIR['til'][0:100]
best['tin'] = AIR['tin']

TQ.MatSave(best,file="best100.ten")
print('finished:',datetime.datetime.now().ctime())
